#ifndef    __ALLOCS_H__
#define    __ALLOCS_H__

#include "types.h"
#include "utils.h"

void * Malloc (size_t size);
char * fdpstrdup (const char * s);

/*****************************************************************************/

dico_list   get_dico_entry  (const char * s);

token_list  str2token       (char * str, token_list next);
var_list    dico2variable   (dico_list name, var_list next);
name_list   dico2name       (dico_list d, name_list n);


dico_list       new_dico_entry (const char * s, dico_list next);

tname_list      new_tname_list (name_list  names, 
                                name_list  type, 
                                tname_list next);

type_list       new_type (dico_list name, type_list next);

pred_list       new_predicate_list (dico_list name, 
                                    tvar_list tvl, 
                                    pred_list next);

func_list       new_function_list (dico_list name, 
                                   tvar_list tvl,
                                   name_list type,
                                   func_list next);

func_term       new_functional_term (func_list func, term_list terms);

numeric_term    new_numeric_term (int type, void * value);

ref_type_list   new_ref_type_list (type_list type, ref_type_list next);

lit_list        new_literal_list (pred_list pred, 
                                  term_list terms,
                                  lit_list  next);

tvar_list       new_tvar_list (var_list vars, name_list type, tvar_list next);

act_list        new_act_list (dico_list    name, 
                              int          status, 
                              tvar_list    params, 
                              lit_list     pre,
                              lit_list     add,  
                              lit_list     del,    
                              numeric_term cost,
                              int          contradicts,
                              act_list     next);

term_list new_term_list (int       type, 
                         void *    item, 
                         term_list next);

constraint new_constraint (int type, var_list m1, void * m2);

const_list new_const_list (constraint cstr, const_list next);

sorted_lit_list new_sorted_lit_list (lit_list litx, sorted_lit_list next);

numeric_term_value new_numeric_term_value (term_list terms, int value,
                                           numeric_term_value next);

/*****************************************************************************/

void free_token_list (token_list tlist);

void free_name_list (name_list nl);

#endif  /* __ALLOCS_H__ */


