%{
/*****************************************************************/ 
/*  lexical analyzer for FDP                                     */
/*                                                               */
/*           Cyril Pain-Barre and Stephane Grandcolas            */
/*  cyril.pain-barre@lsis.org     stephane.grandcolas@lsis.org   */
/*****************************************************************/

/* 
    Apparaissait dans les rgles plus bas:

    Mis en commentaire le 06/10/2005  cause du prdicat
    'next' dans le domaine zeno-travel de IPC-3

    "next"              { return NEXT; }
*/

#include <stdio.h>
#include "utils.h"
#include "pddl.tab.h"

extern int yyval;

%}

comment     ;.*$

%option caseless
%option noyywrap
%option yylineno


%%

"("                 {return '(';}
")"                 {return ')';}

"define"            { return DEFINE; }
"domain"            { return DOMAIN; }
"requirements"      { return REQUIREMENTS; }
"constants"         { return CONSTANTS; }
"types"             { return TYPES; }
"predicates"        { return PREDICATES; }
"problem"           { return PROBLEM; }
"objects"           { return OBJECTS; }
"init"              { return INIT; }
"length"            { return LENGTH;}
"parallel"          { return PARALLEL;}
"serial"            { return SERIAL;}
"control"           { return CONTROL; }
"defpredicate"      { return DEFPREDICATE; }
"exclude"           { return EXCLUDE; }
"wffctrl"           { return WFFCTRL; }
"scope"             { return SCOPE; }
"body"              { return BODY; }
"action"            { return ACTIONS; }
"parameters"        { return PARAMETERS; }
"precondition"      { return PRECONDITION; }
"effect"            { return EFFECT; }
"and"               { return AND; }
"forall"            { return FORALL; }
"exists"            { return EXISTS; }
"noexists"          { return NOEXISTS; }
"not"               { return NOT; }
"goal"              { return GOAL; }
"either"            { return EITHER; }
"fluent"            { return FLUENT; }
"functions"         { return FUNCTIONS; }
"increase"          { return INCREASE; }
"metric"            { return METRIC; }
"minimize"          { return MINIMIZE; }

"-"                 { return '-'; }
":"                 { return ':'; }

[-a-zA-Z0-9_=.]+    { return ID; }
"?"[-a-zA-Z0-9_.]+  { return VAR; }

[ \t]+              ;
{comment}       ;
\n                  yylineno++;

%%
