#include <assert.h>  // assert()

#include "constantes.h"
#include "types.h"
#include "stack.h"
#include "allocs.h"   // Malloc()

/*****************************************************************************/

stack_t alloc_stack (unsigned size)
{
    stack_t s;

    s          = (stack_t) Malloc (sizeof (struct STACK));
    s->entries = (void **) Malloc (size * sizeof (void *));
    s->top     = 0;
    s->size    = size;

    return s;

} // alloc_stack()

/*****************************************************************************/

/* TODO : realloc stack if not enough size */
void push (stack_t s, void * d)
{
    assert (s->top < s->size);
    s->entries [s->top++] = d;

} // push()

/*****************************************************************************/

void * pop (stack_t s)
{
    return (s->entries[--(s->top)]);

} // pop()

/*****************************************************************************/

void rollback (stack_t s)
{
    dico_list * d;
    while ( ! empty_stack (s) )
    {
        d = pop_adr_inst (s);
        if (NULL == d) break;
        *d = NULL;
    }

} // rollback()

