#ifndef    __STACK_H__
#define    __STACK_H__

#include "utils.h"    // var_list, dico_list

typedef struct STACK
{
    void      ** entries;
    unsigned     top;
    unsigned     size;

} * stack_t;

#define empty_stack(s)      ((s)->top == 0)
#define to_empty_stack(s)   ((s)->top = 0)

stack_t alloc_stack    (unsigned size);
void    push           (stack_t s, void * d);
void *  pop            (stack_t s);
void    rollback       (stack_t s);

#define push_NULL(s)            ( push ((s), (void *) NULL ) )
#define push_adr_inst(s, v)     ( push ((s), (void *) &((v)->instance)) )
#define pop_adr_inst(s)         ( (dico_list *) pop (s) )

#define push_var(s, v)          ( push ((s), (void *) (v)) )
#define pop_var(s)              ( (var_list)  pop (s) )

#endif  /* __STACK_H__ */ 
