#ifndef _H_consistance
#define _H_consistance

#include "sets.h"
#include "structures.h"
#include "suppressions.h"

/* #define MULTI_THREADS */
/* #define MULTI_THREADS_FILE */

/* Structures des files d'attentes. */

struct maillon_file_faits {
  int f; /* fait */
  int s; /* etape */
};

struct maillon_file_actions {
  int a; /* action */
  int s; /* etape */
};

/* Files d'attente. */
extern struct maillon_file_faits *FF, *FFF ; /* File des faits a supprimer. */
extern struct maillon_file_actions *AA, *AAA; /* File des actions a supprimer. */
extern struct maillon_file_faits *pF, *dF; /* Premier et dernier de la file. */
extern struct maillon_file_actions *pA, *dA; /* Premier et dernier de la file. */
extern SET FaitsFile;
extern SET ActionsFile;

extern int MKASupp;

/* **************************************************************** */

typedef struct piles_consistance
{
  struct maillon_file_faits *FF, *FFF ;
  struct maillon_file_actions *AA, *AAA;
  struct maillon_file_faits *pF, *dF;
  struct maillon_file_actions *pA, *dA;
  SET FaitsFile;
  SET ActionsFile;
  int MKASupp;
}
  S_CONS;

extern S_CONS * CST;


/* Prototypes. */
void AllocFilesConsistanceThreads(int ne, int thread);
void InitFilesConsistanceThreads(int thread);

void AllocFilesConsistance(int ne, int thread);
void RestitueFilesConsistance(int thread);
void InitFilesConsistance(int thread);
int CountSuppressions(int na, int nf, int ns, int emax, int thread);
int MakeConsistant(int k, int thread);
void PropagerSuppressionDuFait(int f, int s, int ns, int thread);
void PropagerSuppressionDeLAction(int a, int s, int ns, int thread);




/* Macros de traitement des files. */
#ifdef MULTI_THREADS_FILE
#define RETRACT_FILE_FACT(v, i, t, TC) {           	\
    (v) = TC->pF->f;						\
    (i) = TC->pF->s;						\
    TC->pF ++;							\
    /* if (++ TC->pF >= TC->FFF) */				\
    /* TC->pF = TC->FF;	*/					\
    RETe((i)*2*theThreads[(t)].nFaits+(v), TC->FaitsFile);	\
  }
#else
#define RETRACT_FILE_FACT(v, i, t, TC) {           	\
    (v) = pF->f;						\
    (i) = pF->s;						\
    pF ++;							\
    RETe((i)*2*theThreads[(t)].nFaits+(v), FaitsFile);	\
  }
#endif


#ifdef MULTI_THREADS_FILE
#define RETRACT_FILE_ACTION(v, i, t, TC) {		\
    (v) = TC->pA->a;						\
    (i) = TC->pA->s;						\
    TC->pA ++;							\
    /* if (++ TC->pA >= TC->AAA) */				\
    /* TC->pA = TC->AA;	*/					\
    RETe((i)*theThreads[(t)].nActions+(v),TC->ActionsFile);	\
  }
#else
#define RETRACT_FILE_ACTION(v, i, t, TC) {		\
    (v) = pA->a;						\
    (i) = pA->s;						\
    pA ++;							\
    RETe((i)*theThreads[(t)].nActions+(v),ActionsFile);	\
  }
#endif


#ifdef MULTI_THREADS_FILE
#define ADD_FILE_FACT(v, i, T, TC) {			 \
    if ( ! IN((i)*2*(T).nFaits+(v), TC->FaitsFile)) {	 \
      ADDe((i)*2*(T).nFaits+(v), TC->FaitsFile);	 \
      TC->dF->f = (v);					 \
      TC->dF->s = (i);					 \
      TC->dF ++;					 \
      /* if (++ TC->dF > TC->FFF)*/			 \
      /*TC->dF = TC->FF;*/				 \
    }							 \
  }
#else
#define ADD_FILE_FACT(v, i, T, TC) {			 \
    if ( ! IN((i)*2*(T).nFaits+(v), FaitsFile)) {	 \
      ADDe((i)*2*(T).nFaits+(v), FaitsFile);	 \
      dF->f = (v);					 \
      dF->s = (i);					 \
      dF ++;					 \
    }							 \
  }
#endif


#ifdef MULTI_THREADS_FILE
#define ADD_FILE_ACTION(v, i, T, TC) {		   \
    if ( ! IN((i)*(T).nActions+(v), TC->ActionsFile)) {	   \
    /* printf("add file action %d step %d\n", v, i); */\
      ADDe((i)*(T).nActions+(v), TC->ActionsFile);	   \
      TC->dA->a = (v);					   \
      TC->dA->s = (i);					   \
      TC->dA ++;					   \
      /* if (++ TC->dA > TC->AAA) */			   \
      /* TC->dA = TC->AA; */				   \
    }							   \
  }
#else
#define ADD_FILE_ACTION(v, i, T, TC) {		   \
    if ( ! IN((i)*(T).nActions+(v), ActionsFile)) {	   \
      ADDe((i)*(T).nActions+(v), ActionsFile);	   \
      dA->a = (v);					   \
      dA->s = (i);					   \
      dA ++;					   \
    }							   \
  }
#endif





/* Macros de traitement des ensembles Fi et Ai du graphe d'actions. */

#ifdef MULTI_THREADS
#define ADD_FACT(v, i, G) {				    \
    G->Fi[i][(v)] = 1;					    \
    (G->nFi[i]) ++;					    \
    if ( ! Goals[(v)]) /* G->Fi[i][OPPOSE(v)] est vrai. */  \
      G->nFixedGoals[i] --;				    \
    if (Goals[OPPOSE(v)] == 0)				    \
      {							    \
	G->nButs[i] ++;					    \
	if ((G->nButs[i] == nGoals) && (G->AllGoals > i))   \
	  G->AllGoals = i;				    \
      }							    \
  }
#else
#define ADD_FACT(v, i, G) {				    \
    Fi[i][(v)] = 1;					    \
    (nFi[i]) ++;					    \
    if ( ! Goals[(v)]) /* Fi[i][OPPOSE(v)] est vrai. */  \
      nFixedGoals[i] --;				    \
    if (Goals[OPPOSE(v)] == 0)				    \
      {							    \
	nButs[i] ++;					    \
	if ((nButs[i] == nGoals) && (AllGoals > i))   \
	  AllGoals = i;				    \
      }							    \
  }
#endif


#ifdef MULTI_THREADS
#define RETRACT_FACT(v, i, t, G) {				\
    G->Fi[i][(v)] = 0;						\
    (G->nFi[i]) --;						\
    EMPILER_FSUPPR(v, i, t);					\
    if ( ! Goals[(v)])						\
      G->nFixedGoals[i] ++;					\
    if ( ! Goals[OPPOSE(v)]) {					\
      G->nButs[i] --;						\
      if (G->AllGoals == i)					\
	do							\
	  G->AllGoals ++;					\
	while (G->nButs[G->AllGoals] != nGoals);		\
    }								\
  }
#else
#define RETRACT_FACT(v, i, t, G) {				\
    Fi[i][(v)] = 0;						\
    (nFi[i]) --;						\
    EMPILER_FSUPPR(v, i, t);					\
    if ( ! Goals[(v)])						\
      nFixedGoals[i] ++;					\
    if ( ! Goals[OPPOSE(v)]) {					\
      nButs[i] --;						\
      if (AllGoals == i)					\
	do							\
	  AllGoals ++;					\
	while (nButs[AllGoals] != nGoals);		\
    }								\
  }
#endif



#ifdef MULTI_THREADS
#define ADD_ACTION(v, i, G) {			\
    G->Ai[i][(v)] = 1;				\
    if (G->nAi[i] == 1)				\
      G->nAiSingles --;				\
    G->tAi[i][G->nAi[i]] = v;				\
    G->itAi[i][v] = G->nAi[i];			\
    G->nAi[i] ++;					\
  }
#define RETRACT_ACTION(v, i, t, G) {		\
    G->Ai[i][(v)] = 0;				\
    G->nAi[i] --;					\
    if (G->nAi[i] == 1)				\
      G->nAiSingles ++;				\
    G->tAi[i][G->itAi[i][v]] = G->tAi[i][G->nAi[i]];	\
    G->itAi[i][G->tAi[i][G->nAi[i]]] = G->itAi[i][v];	\
    EMPILER_ASUPPR(v, i, t);			\
  }
#else
#define ADD_ACTION(v, i, G) {			\
    Ai[i][(v)] = 1;				\
    if (nAi[i] == 1)				\
      G->nAiSingles --;				\
    tAi[i][nAi[i]] = v;				\
    itAi[i][v] = nAi[i];			\
    nAi[i] ++;					\
  }
#define RETRACT_ACTION(v, i, t, G) {		\
    Ai[i][(v)] = 0;				\
    nAi[i] --;					\
    if (nAi[i] == 1)				\
      G->nAiSingles ++;				\
    tAi[i][itAi[i][v]] = tAi[i][nAi[i]];	\
    itAi[i][tAi[i][nAi[i]]] = itAi[i][v];	\
    EMPILER_ASUPPR(v, i, t);			\
  }
#endif



#endif
