#if ! defined __HASH_H__
#define       __HASH_H__

#include <stdlib.h>

#include "utils.h"

#define HASH_SIZE 262261
/* #define HASH_SIZE 262144 */  /* 10000000000000 */

#define SIZE_SEG_HASH 32


extern int sizeStates;

extern unsigned int sizeHT;
extern unsigned int changesHT;

typedef struct hash_list_elt * hash_list;

struct hash_list_elt
{
  unsigned int * etat;     /* la liste des faits de l'tat */

  int distance;            /* borne max : en dessous c'est un nogood */

  unsigned char * dists; 
  DLIST distcosts;       /* liste des distances/couts (cfdp). */

  hash_list next;
} ;


typedef struct hash_table_elt
{
    int   nombre;
    hash_list  liste;

} * hash_table_t;

extern hash_table_t HT; /* La table des echecs (forward depth first search). */

extern hash_list CurrentHash; 
extern unsigned int *CurrentState;


int hashSteph (int nfaits, int *etat, unsigned int *p);
hash_table_t alloc_hash_table (size_t size, int nfaits);
void free_hash_table (hash_table_t ht, size_t size);
void dump_hash_table (hash_table_t table, size_t size);
void AffStatsHash(hash_table_t table, size_t size);
unsigned int * duplicate (unsigned int *E, int size);

int search_hash_state (hash_table_t table, int h, int distance, hash_list * CH, unsigned int *CS);
int meme_bits_etat (unsigned int *e1, unsigned int *e2);
void ajouter_etat_hash (hash_table_t table, unsigned int *e,  hash_list ch,
			int distance , int h, int all, int ns);
unsigned int hash_bits (unsigned int *etat, int sizeStates);
hash_list new_hash_list (unsigned int * etat, int distance, 
			 unsigned char * dists, hash_list next);




#endif     /* __HASH_H__ */
