#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "hashstrings.h"
#include "structures.h"

hs_table alloc_hs_table (void)
{
    int i;
    hs_table ht, p;

    ht = (hs_table) malloc(HASH_STRING_SIZE*sizeof(struct hs_table_elt));
    assert (ht != NULL);
    p = ht;

    for (i = 0; i < HASH_STRING_SIZE; ++i)
    {
        p->nombre = 0;
        p->list  = NULL;
        ++p;
    }
    return ht;
}

int hs_hash (char *s)
{
  int h = 0;

  while (*s != '\0')
    {
      h = (h*257+*s)%HASH_STRING_SIZE;
      s++;
    }
  return h;
}

int search_fact_hs_table(char *s, hs_table ht, FAIT facts)
{
  hs_list p = ht[hs_hash(s)].list;
  
  while (p != NULL)
    {
      if (strcmp(facts[2*p->elt].nom, s) == 0)
	return (p->elt);
      p = p->suiv;
    }
  return NOT_IN_HS;
}

int search_action_hs_table(char *s, hs_table ht, ACTION actions)
{
  hs_list p = ht[hs_hash(s)].list;
  
  while (p != NULL)
    {
      if (strcmp(actions[p->elt].nom, s) == 0)
	return (p->elt);
      p = p->suiv;
    }
  return NOT_IN_HS;
}

void add_hs_table(char *s, hs_table ht, int f)
{
  hs_table q = ht+hs_hash(s);
  hs_list p = malloc(sizeof(struct hs_list_maillon));
  
  assert(p != NULL);
  p->suiv = q->list;
  p->elt = f;
  q->list = p;
  q->nombre++;
}

void verif_hs_table(hs_table ht, ACTION actions, int n)
{
  int *t = malloc(n*sizeof(int));
  int i, k = 0;
  hs_list p;

  for (i = 0; i < HASH_STRING_SIZE; i++)
    for (p = ht[i].list; p != NULL; p = p->suiv)
      {
	t[p->elt] = 1;
	k++;
      }
  if (k != nActions)
    printf("OUYE HS TABLE ACTIONS\n");
  free(t);
}
