#ifndef _H_hasht
#define _H_hasht

#include "hash.h"
#include "utils.h"
#include "structures.h"

#define RSV_INIT_SIZE 500000
#define RSV_EXPANSION 100000

typedef struct hasht
{
  struct hash_table_elt * t;
  int size;         /* taille de la table. */
  int size_states;  /* taille des etats memorises en sizeof(unsigned int) */

  struct hash_list_elt * rsv; /* reservoir de maillons. */
  int size_rsv;                   /* taille du reservoir. */
  struct hash_list_elt * top_rsv;

  LIST rsv_list;
}
  * HASHT;



HASHT newHashTable (int size, int size_sets, int srsv);
void freeHashTable (HASHT H);
void reallocHashTableReserve (HASHT H);

hash_list newHashElt (HASHT H, unsigned int *etat, int distance, 
		      unsigned char * dists, hash_list next);
void retractHashElt (HASHT H, int h, hash_list the);

int searchStateCostHashTable (HASHT H, int h, int distance, hash_list * pp,
			      DLIST *cur, S_GR * G);
void addStateCostHashTable (HASHT H, int h, int d, int c, hash_list e, 
			    DLIST cur, unsigned int *state);



#endif
