#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* #include <signal.h> */  /* signal() */
#include <unistd.h>  /* alarm() */
#include <time.h>

#define PUBLIC_EDITION


#include "pddl.h"

#include "main.h"
#include "search.h"
#include "stats.h"
#include "structures.h"

int timelimit = 0;  /* limite du temps */

/* void DeroutAlarm (int sig) */
/* { */
/*     printf ("aborted after %d seconds\n", timelimit); */
/*     exit (1); */
/* } */

char * NomFicDomaine  = "<stdin>";
char * NomFicProbleme = "<stdin>";
FILE * FicDomaine;  /* = stdin */
FILE * FicProbleme; /* = stdin */


/* Choix generaux. */
unsigned int SearchMode = (unsigned int) FDP_MINCOST_SEARCH;
int nThreads       = 1;
int noThreads      = 1;

int regressionProc = 0;
int expandProc     = 0;


int nSteps          = 0; 
int nStepsImposed   = 200;
int nStepsInProblem = 0;
int FirstSolution   = 1;

int removeActionsWithOppositeEffects = 0;


/* Options de methodes. */
int ComputeParallelPlan = 0;

int Sequences2Actions = 0;
int Sequences2ActionsInEnumerate = 1;
int Constraint2SequencesInSequence = 0; 
int MaxSize2SeqFiltering = 1000000; 
int ModeDetection2Seq = STD_IPC5;
int Mode2SeqIPC5Croissante = 1;

int ForceNoop = 0;

int ConstructPred2SeqSets = 0; 

int FilterSomeActions = 0;
int ModeFilterSomeActions = 0;
int PerFilterSomeActions = 100;



int CalculMinSteps = 1;
int MinStepsPlus = 0; /* inutilise */

int ModeDecomposition = ACTIONS_ENUM;
int ModeDecompEnsuite = ACTIONS_ENUM;
int ModeChoixEtape = EN_PARTANT_DU_DEBUT;
int ModeChoixEtapeEnsuite = EN_PARTANT_DU_DEBUT;

int ModeEvaluationActions = EVAL_ACTION_ADD_MOST_GOALS;
int OrdActionsEnum = 1;

int ChoixEtapeFaitForSplit = 0;
int SizeSplitMin = 2;
int FullSplit = 0;
int OrdSplitLevels = 0;
int ProfSplitMax = INT_MAX;

/* Options d'affichage. */
int AfficherLeProbleme = 0;
int AfficherLeGraphe = 0;
int AfficheSolution = 0;
int Verbose = 0;
int IPCOutput = 0;

/* Parametres minimal costs search. */
int randomCosts = 0;
int sizeMinCosts = 3;
int timeLimitMinCosts = 100;


/* SECONDAIRES */
int ShakeActions = NO_SHAKE;
int ActionsShakeSeed;

int UseActionsMutex = 0;
int UseFactsMutex = 0;
int MaintainMutexes = 0;
int APrioriMutexes = 0;
int NextStepMutexes = 0;

int ModeProbleme = LECTURE;
int SeedBWGeneration = -1;
int nBlocsBW = 3;

int UseHashCyril    = 0;

int DumpHash = 0;



void
PrintOptions(void)
{
  int AfficherModeLecture = 0;

  printf("[");
  if (AfficherModeLecture)
      {
	printf("LS%d", nSteps);
	if (nStepsImposed) printf ("!");
	else if (nStepsInProblem) printf ("+");
	printf (" ");
      }

  if (SearchMode & FDP_MINCOST_SEARCH)
    printf("CFDP");

  if (ModeDecomposition == ACTIONS_ENUM)
    printf("Ae-");
  else 
    {
      printf("Ss");
      printf("%dp-", SizeSplitMin);	
    }
  if ((Sequences2Actions) || (Sequences2ActionsInEnumerate)) {
    printf("2Sq-");
  }
}


int
main(int argc, char **argv)
{
  int i, tmp;
  char *endptr;
  
/*   signal (SIGALRM, DeroutAlarm); */
  FicDomaine  = stdin;
  FicProbleme = stdin;

  srand(time(NULL));

  for (i = 1; i < argc; i++)
    {
	if (strcmp (argv[i], "-d") == 0)
      {
        if (i >= argc-1) goto USAGE;
        FicDomaine = fopen (argv[i+1], "r");
        NomFicDomaine = strdup (argv[i+1]);
        if (FicDomaine == NULL)
        {
           printf ("Fichier domaine %s introuvable\n", argv[i+1]);
           return 1;
        }
        i++;
      }
      else if (strcmp (argv[i], "-p") == 0)
      {
        if (i >= argc-1) goto USAGE;
        FicProbleme = fopen (argv[i+1], "r");
        NomFicProbleme = strdup (argv[i+1]);
        if (FicProbleme == NULL)
        {
           fprintf (stderr, "Fichier probleme %s introuvable\n", argv[i+1]);
           return 1;
        }
        i++;
      }
      else if (strcmp (argv [i], "-TIMELIMIT") == 0)
      {
        if (i >= argc-1) goto USAGE;
        tmp = strtol(argv[i+1], &endptr, 10);
        if ((argv[i+1][0] == '\0') || (*endptr != '\0'))
          goto USAGE;
        timelimit = tmp;
        i++;
      }
      else if (strcmp(argv[i], "-NB_STEPS!") == 0)
      {
        if (++i == argc) goto USAGE;
        nStepsImposed = strtol(argv[i], &endptr, 10);
        if ((argv[i][0] == '\0') || (*endptr != '\0')) goto USAGE;
      }
      /* Fin des ajouts par Cyril */

      else if (strcmp(argv[i], "-CFDP") == 0)
	{
	  SearchMode |= (unsigned int) FDP_MINCOST_SEARCH;
	  Sequences2ActionsInEnumerate = 1;
	  ModeDetection2Seq = STD_IPC5;
	  if (i+1 < argc)
	    {
	      int size = strtol(argv[i+1], &endptr, 10);
	      if (*endptr == '\0')
		{
		  sizeMinCosts = size;
		  i = i+1;
		  if (i+1 < argc)
		    {
		      int lim = strtol(argv[i+1], &endptr, 10);
		      if (*endptr == '\0')
			{
			  timeLimitMinCosts = lim;
			  i = i+1;
			}
		    }
		}
	    }
	}
      else if (strcmp(argv[i], "-RANDOM_COSTS") == 0)
	randomCosts = 1;

      else
       if (strcmp(argv[i], "-AFF_PROBLEME") == 0)
	AfficherLeProbleme = 1;
      else if (strcmp(argv[i], "-NB_STEPS") == 0)
	{
	  if (++i == argc)
	    goto USAGE;
	  nSteps = strtol(argv[i], &endptr, 10);
	  if ((argv[i][0] == '\0') || (*endptr != '\0'))
	    goto USAGE;
	}
      else if (strcmp(argv[i], "-VERBOSE") == 0)
	Verbose = 1;
      else if (strcmp(argv[i], "-IPC_OUTPUT") == 0)
	IPCOutput = 1;
      else if (strcmp(argv[i], "-AFF_SOLUTION") == 0)
	AfficheSolution = 1;


      else if (strcmp(argv[i], "-SPLIT") == 0)
	ModeDecomposition = ACTIONS_2SPLIT_COMMON_SUPP;
      else if (strcmp(argv[i], "-SIZE_SPLIT_MIN") == 0)
	{
	  if (++i == argc)
	    goto USAGE;
	  SizeSplitMin = strtol(argv[i], &endptr, 10);
	  if ((argv[i][0] == '\0') || (*endptr != '\0'))
	    goto USAGE;
	  if (SizeSplitMin <= 1)
	    SizeSplitMin = 2;
	}
      else if (strcmp (argv [i], "-INIT_RAND") == 0)
	{
	  if (i >= argc-1) goto USAGE;
	  tmp = strtol(argv[i+1], &endptr, 10);
	  if ((argv[i+1][0] == '\0') || (*endptr != '\0'))
	    goto USAGE;
	  srand(tmp);
	  i++;
	}
      else
	goto USAGE;
    }
/*   alarm (timelimit); */
  
  Search(ModeProbleme, SearchMode);

  return 0;

 USAGE:
  printf ("-v|--version :: version\n");
  printf ("-d <fichier domaine>\n");
  printf ("-p <fichier probleme>\n");
  printf ("-TIMELIMIT <seconds> :: limite en nombre de secondes\n");
  printf ("-NB_STEPS! <nombre d'tapes> :: outrepasse nombre d'tapes indiqu\n");
  printf("-NB_STEPS <nombre d'etapes> :: nombre d'etapes si non indique\n");
  printf("-AFF_PROBLEME :: affiche le probleme.\n");
  printf("-AFF_SOLUTION :: affichage des solutions.\n");
  printf("-VERBOSE :: affichage temps intermediaires.\n");
  printf("-IPC_OUTPUT :: affichage pour IPC5.\n");
  printf("-CFDP [size max] [time limit] :: Recherche un plan de cout minimal.\n\
Recherche en avant sur un graphe dont les buts ne sont pas fixes.\n");
  printf("-SPLIT :: split d'un ensemble d'actions (suppressions communes).\n");
  printf("-SIZE_SPLIT_MIN <size> :: taille minimale des parties quand on splitte. Si |Ai| est trop petit on enumere sur les actions.\n");
  printf("-INIT_RAND [<seed>] :: initialisation de la sequence aleatoire.\n");

  return 1;
}

