#ifndef _H_main
#define _H_main

#include "structures.h"

/* Modes de generation/lecture. */
#define LECTURE 0
#define BW_STACK 1
#define BW_RANDOM 2



/* Modes de decompositions. */
#define FACTS_ENUM 0
#define ACTIONS_ENUM 1
/* Attention ! l'ordre est utilise (SPLIT si >= 2). */
#define ACTIONS_2SPLIT_COMMON_SUPP 2
#define ACTIONS_2SPLIT_COMMON_ADD 3
#define ACTIONS_2SPLIT_COMMON_REQ 4
#define ACTIONS_2SPLIT_DISTANCES 5


/* Modes de choix de l'etape (actions). */
#define PREMIER_PLUS_PETIT_Ai 0
#define UN_PLUS_PETIT_Ai 1
#define PREMIER_PLUS_GRAND_Ai 2
#define UN_PLUS_GRAND_Ai 3
#define MEDIAN_SEQUENCE_PLUS_GRANDS_Ai 4
#define EN_PARTANT_DE_LA_FIN 5
#define EN_PARTANT_DU_DEBUT 6

/* Modes ShakeActions. */
#define NO_SHAKE 0
#define SHAKE_SEED 1
#define SHAKE_RANDOM 2

/* Modes pour l'evaluation des actions. */
#define EVAL_FROM_MATURITE_AJOUTS 0
#define EVAL_SUPPR_PROPAGATION 1
#define EVAL_ALLGOALSLEVEL 2
#define EVAL_ACTION_ADD_MOST_GOALS 3
#define EVAL_ACTIONS_CHANGE_LEVEL 4

/* Modes pour l'evaluation des faits. */
#define EFACT_ACTIONS_SUPPRESSIONS 0
#define EFACT_FACTS_NEXT_LEVEL 1
#define EFACT_REQUETES 2

#define EFACT_ALLGOALSLEVEL 4
#define EFACT_GOALS_NEXT_LEVEL 5
#define EFACT_CUMUL_AJOUTS_BUTS 6
#define EFACT_AVG_AJOUTS_BUTS 7
#define EFACT_MAX_AJOUTS_BUTS 8

#define EFACT_MEILLEUR_FAIT 10
#define EFACT_SUPPRESSIONS 11
#define EFACT_RANDOM 12

/* Search modes */
#define FDP_MINCOST_SEARCH 64

/* Choix generaux. */
extern unsigned int SearchMode;
extern int nThreads;
extern int noThreads;

extern int regressionProc;
extern int expandProc;



extern int nSteps;
extern int nStepsImposed;
extern int nStepsInProblem;
extern int FirstSolution;

extern int removeActionsWithOppositeEffects;


/* Options de methodes. */
extern int ComputeParallelPlan;

extern int Sequences2Actions;
extern int Sequences2ActionsInEnumerate;
extern int Constraint2SequencesInSequence;
extern int MaxSize2SeqFiltering;

extern int ModeDetection2Seq;
#define STD_IPC5 0 /* Habituel : comme a IPC5. */
#define ORD2SEQDEP 1  /* Base sur les actions dependantes. */
#define ORD2SEQDEPi 2 /* Actions dependantes avec verification locale. */
#define ORD2SEQVIDAL 3 /* A partir de la definition d'exclusion mutuelle
			  de Vidal. */
extern int Mode2SeqIPC5Croissante; /* Avec STD_IPC5 : admet i<j, rejette i>j 
				      quand 
				      i et j sont independantes. */

extern int ForceNoop;

extern int ConstructPred2SeqSets;


extern int FilterSomeActions;
extern int ModeFilterSomeActions;
extern int PerFilterSomeActions;


extern int CalculMinSteps;
extern int MinStepsPlus;

extern int ModeDecomposition;
extern int ModeDecompEnsuite;
extern int ModeChoixEtape;
extern int ModeChoixEtapeEnsuite;

extern int ModeEvaluationActions;
extern int OrdActionsEnum;

extern int ChoixEtapeFaitForSplit;
extern int SizeSplitMin;
extern int FullSplit;
extern int OrdSplitLevels;
extern int ProfSplitMax;


/* Options d'affichage. */
extern int AfficherLeProbleme;
extern int AfficherLeGraphe;
extern int AfficheSolution;
extern int Verbose;
extern int IPCOutput;



/* Parametres minimal costs search. */
extern int randomCosts;
extern int sizeMinCosts;
extern int timeLimitMinCosts;


/* SECONDAIRES */
extern int ShakeActions;
extern int ActionsShakeSeed;

extern int UseActionsMutex;
extern int UseFactsMutex;
extern int MaintainMutexes;
extern int APrioriMutexes;
extern int NextStepMutexes;

extern int ModeProbleme;
extern int SeedBWGeneration;
extern int nBlocsBW;

extern int UseHashCyril;      /* Ajout Cyril */

extern int  DumpHash; 

extern int timelimit;

void PrintOptions(void);

#endif
