#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>


#include "main.h"
#include "minsteps.h"
#include "structures.h"
#include "consistance.h"
#include "search.h"


int MinStepsRemoveActions = 1;

int ** nGoalsAdded;  /* Pour chaque thread, une table indicee sur les etapes
			avec les nombres de buts ajoutes. */



int date_ms;



/* ************************************************************** */
/* ********************* GREEDY EVALUATION ********************** */
/* ************************************************************** */
/* A chaque etape on choisit l'action qui ajoute le plus de buts manquants.
   On calcule au fur et a mesure le nombre max de buts possiblement ajoutes. */


int MinStepMaxAdds(int e, int ns, int thread, int mode)
{
  if (mode == MS_REMOVE_ACTIONS)
    return MinStepMaxAddsRemoveActions(e, ns, thread, TheGoals, Goals);

  if (mode == MS_DONT_REMOVE_ACTIONS)
    return MinStepMaxAddsDontRemoveActions(e, ns, thread, TheGoals, Goals);

  return 1;
}


int MinStepMaxAddsDontRemoveActions(int e, int ns, int thread, int *Goals, int *isGoal)
{
  int nga, *pa, s, nG, *p;
  S_GR * G = &(GRT[thread]);

  for (p = Goals, nG = 0; *p != FNIL; p ++)
    if ( ! G->Fi[e][*p])
      nG ++;

  if (nG == 0)
    return MS_SUCCESS;

  for (s = ns-1; s >= e; s --)
    {
      /* On cherche l'action qui ajoute le max de buts. */
      for (pa = G->tAi[s], nga = 0; pa < G->tAi[s]+G->nAi[s]; pa ++)
	{
	  int ngs = 0;

	  /* on compte les buts manquants a l'etape e qui sont ajoutes par pa. */
	  for (p = LesActions[*pa].add; *p != FNIL; p++)
	    if (( ! isGoal[OPPOSE(*p)]) && ( ! G->Fi[e][*p]))
	      ngs++;
	  if (ngs > nga)
	    {
	      nga = ngs;
	      if (ngs == maxGAdds)
		break;
	    }
	}
      if (nga > 0)
	{
	  nG -= nga;
	  if (nG <= 0)
	    return MS_SUCCESS;
	}
    }
  return MS_FAILURE;
}



int MinStepMaxAddsRemoveActions(int e, int ns, int thread, int *Goals, int *isGoal)
{
  int nga, cnga, *pa, s, nG, *p;
  S_GR * G = &(GRT[thread]);
  int status = MS_SUCCESS;
  int * NGA;

  if (nGoalsAdded[thread] == NULL)
    {
      nGoalsAdded[thread] = malloc((theThreads[thread].nsmax)*sizeof(int));
      assert(nGoalsAdded[thread] != NULL);
    }
  NGA = nGoalsAdded[thread];

  for (p = Goals, nG = 0; *p != FNIL; p ++)
    if ( ! G->Fi[e][*p])
      nG ++;

  if (nG == 0)
    return MS_SUCCESS;

/*   printf("miss %d / %d steps  : ", nG, ns-e); */

  for (s = ns-1, cnga = 0; s >= e; s --)
    {
      /* On cherche l'action qui ajoute le max de buts. */
      for (pa = G->tAi[s], nga = 0; pa < G->tAi[s]+G->nAi[s]; pa ++)
	{
	  int ngs = 0;

	  /* on compte les buts manquants a l'etape e qui sont ajoutes par pa. */
	  for (p = LesActions[*pa].add; *p != FNIL; p++)
	    if (( ! isGoal[OPPOSE(*p)]) && ( ! G->Fi[e][*p]))
	      ngs++;
	  if (ngs > nga)
	    {
	      nga = ngs;
	      if (ngs == maxGAdds)
		break;
	    }
	}
      NGA[s] = nga;
      cnga += nga;
    }

  if (cnga < nG)
    return MS_FAILURE;


  if (cnga == nG)
    {
      for (s = ns-1; s >= e; s --)
	if (NGA[s] > 0)
	  for (pa = G->tAi[s]; pa < G->tAi[s]+G->nAi[s]; pa ++)
	    {
	      int ngs = 0;

	      /* on compte les buts manquants a l'etape e qui sont ajoutes par pa. */
	      for (p = LesActions[*pa].add; *p != FNIL; p++)
		if (( ! isGoal[OPPOSE(*p)]) && ( ! G->Fi[e][*p]))
		  ngs ++;
	      if (ngs < NGA[s])
		{
#ifdef MULTI_THREADS_FILE
		  S_CONS * TC = &(CST[thread]);
#endif
		  ADD_FILE_ACTION(*pa, s, theThreads[thread], TC);
		  status = MS_ACTION_REMOVED;
		}
	    }
    }

  return status;
}



