#ifndef _H_sequences
#define _H_sequences

/* Les 2sequences sont representees par des tables ou par des SETS pour un 
   gain de place important (nA*nA). */
/* #define ORDERED2SEQ_ARRAYS */
#define ORDERED2SEQ_SETS



/* Macros 2-sequences. */
#ifdef ORDERED2SEQ_SETS
#define IS_2SEQ(a,b) (IN((b), Seq2Actions[(a)]))
#endif
#ifdef ORDERED2SEQ_ARRAYS
#define IS_2SEQ(a,b) (Seq2Actions[(a)][(b)])
#endif



#ifdef ORDERED2SEQ_SETS
extern SET * Seq2Actions;
extern SET * pred2SeqSet;
#endif
#ifdef ORDERED2SEQ_ARRAYS
extern char **Seq2Actions;
#endif

extern int **Next2Actions;
extern int *nNext2Actions;
extern int **Prev2Actions;
extern int *nPrev2Actions;
extern int **NbSucc2Seq, **NbPre2Seq;


void ConstructionSequences2Actions(void);
void BonneSequence2Actions(int i, int j);

int FilterNextStep2Sequences(int e, int ns, int t);
int FilterNextStepUnorderedActions(int a, int e, int ns, int t);
int FilterPreviousStepUnorderedActions(int a, int e, int ns, int t);



#endif
