
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "cardinaux.h"
#include "sets.h"

TYPESEG fullPartialSegment [] = {
  0, 1, 3, 7, 15, 31, 63, 127, 255, 511, 1023, 2047, 4095, 8191, 16383, 32767, 
  65535, 131071, 262143, 524287, 1048575, 2097151, 4194303,
  8388607, 16777215, 33554431, 67108863, 134217727, 268435455, 
  536870911, 1073741823, 2147483647};
/* 4294967295 */


SET AllocSet(int n)
{
  SET s;
 
  s = calloc((n-1) / SIZESEG + 3, sizeof(TYPESEG));
  assert(s != NULL);
  TAILLE(s) = (n-1) / SIZESEG + 1;
  CARD(s) = 0;
  return s;
}

void RestitueSet(SET s)
{
  free(s);
}

void VideSet(SET s)
{
  unsigned int * p = s+TAILLE(s)+1;
  
  while (p > s+1)
    *p -- = (TYPESEG) 0;
/*   int i; */
  
/*   for (i = 2; i < TAILLE(s)+2; i++) */
/*     *(s+i) = (TYPESEG) 0; */
  CARD(s) = 0;
}

void FillSet(SET s, int n)
{
  int i;
  
  for (i = 2; i < 2+n/SIZESEG; i++)
    *(s+i) = ~((TYPESEG) 0);

  if (n%SIZESEG != 0)
    *(s+i) = (TYPESEG) fullPartialSegment [n%SIZESEG];

  CARD(s) = n;
}

void CopieSet(SET s, SET d)
{
  int i;
 
  TAILLE(d) = TAILLE(s);
  CARD(d) = CARD(s);
  for (i = 2; i < TAILLE(s)+2; i++)
    *(d+i) = *(s+i);
}

int nCommuns(SET s1, SET s2)
{
  int i, n = 0;
  TYPESEG S;
  unsigned char *c;
 
  for (i = 2; i < TAILLE(s1)+2; i++)
    {
      S = *(s1+i)&*(s2+i);
      c = (unsigned char *) (&S);
      n += Cardinal[*c]+Cardinal[*(c+1)]+Cardinal[*(c+2)]+Cardinal[*(c+3)];
    }
  return n;
}

int nFaitsCommunsInSet(SET s1, SET s2)
{
  int i, n = 0;
  TYPESEG S1, S2;
 
  for (i = 2; i < TAILLE(s1)+2; i++)
    {
      S1 = *(s1+i);
      S2 = *(s2+i);
      while (S1 || S2)
	{
	  if ((S1%4 == S2%4) && (S1%4 != 3))
	    n ++;
	  S1 = (S1 >> 2);
	  S2 = (S2 >> 2);
	}
    }
  return n;
}

int SubSet(SET u, SET s)
{
  int i;
  
  for (i = 2; i < TAILLE(u)+2; i++)
    if ((*(u+i)&*(s+i)) != *(u+i))
      return 0;
  return 1;
}

int SupSet(SET u, SET s)
{
  int i;
  
  for (i = 2; i < TAILLE(u)+2; i++)
    if ((*(u+i)&*(s+i)) != *(s+i))
      return 0;
  return 1;
}

char SeRecoupent(SET s1, SET s2)
{
  int i;
 
  for (i = 2; i < TAILLE(s1)+2; i++)
    if ((*(s1+i)&*(s2+i)) != (TYPESEG) 0)
      return 1;
  return 0;
}


void FactsLevelToSet(int * F, int nf, SET S)
{
  int i;
  TYPESEG * p = S+SEGMARGIN;

  for (i = 0, *p = (TYPESEG) 0; i < nf; i ++)
    {
      if ( F[2*i] )
	{
	  if ( ! F[2*i+1] )
	    *p = (*p)|(((TYPESEG) 1) << ((2*i)%SIZESEG));
	}
      else if ( F[2*i+1] )
	*p = (*p)|(((TYPESEG) 1) << ((2*i+1)%SIZESEG));
      if ((2*i+2)%SIZESEG == 0)
	{
	  p ++;
	  *p = (TYPESEG) 0;
	}
    }
  CALCARD(S);
}
