#include <limits.h>
#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


#include "constantes.h"
#include "consistance.h"
#include "fdp.h"
#include "main.h"
#include "search.h"
#include "structures.h"
#include "split.h"
#include "stats.h"

/* Ceci pour les distances entre les actions. Pas utilise. */
int ** DA; /* Table des distances. */
int *AS1, *AS2; /* Les 2 ensembles apres le split. */
int nAS1, nAS2;

int *** S4S; /* Sets for split. */
int *** tS4S; /* top. */
int sS4S;    /* La taille de la table allouee. */

int ModeActionsDistance = ACTIONS_SUCC_COMMUNES;

void AddActionsSetToQueue(int * S, int e, int t)
/* t: le numero du thread */
{
#ifdef MULTI_THREADS_FILE
  S_CONS * TC = &(CST[t]);
#endif
  S_GR * G = &(GRT[t]);

  while (*S != FNIL)
    {
      if (G->Ai[e][*S])
	ADD_FILE_ACTION(*S, e, theThreads[t], TC);
      S++;
    }
}

void AllocActionsSetsForSplit(int na, int ns)
{
  AS1 = malloc((na+1)*sizeof(int));
  assert(AS1 != NULL);
  AS2 = malloc((na+1)*sizeof(int));
  assert(AS2 != NULL);

  sS4S = (1+(int) logf((float) na)) * (ns+1) + 1;
  tS4S = S4S = calloc(sS4S, sizeof(int **));
  assert(S4S != NULL);
}

extern int ** DGL;

int SplitAiFromFact(int e, int f, int relation, int **S1, int **S2, 
		    int ns, int thread)
/* S'arrange pour que S1 soit le plus petit. */
{
  int *t, *s1, *s2, n1, n2;
  int i;
  int chg1, chg2;
  S_GR * G = &(GRT[thread]);
  int na = theThreads[thread].nActions;
  
  if (*(G->tS4S) == NULL)
    {
      *(G->tS4S) = malloc(2*sizeof(int *));
      assert(*(G->tS4S) != NULL);
      (*(G->tS4S))[0] = malloc((na+1)*sizeof(int));
      assert((*(G->tS4S))[0] != NULL);
      (*(G->tS4S))[1] = malloc((na+1)*sizeof(int));
      assert((*(G->tS4S))[1] != NULL);
    }

  s1 = *S1 = (*(G->tS4S))[0];
  s2 = *S2 = (*(G->tS4S))[1];

  if (OrdSplitLevels && (e >= 0))
    {
      chg1 = chg2 = n1 = n2 = 0;
      switch (relation)
	{
	case ISSUPP: /* DEFAULT */
	  for (i = 0, t = G->tAi[e]; i < G->nAi[e]; i++, t++)
	    if ((LesActions+(*t))->issup[f])
	      { *s1 ++ = *t; n1 ++ ; chg1 = chg1+G->DGL[e][*t]-1; }
	  /* 	  *s1 ++ = *t; */
	    else
	      { *s2 ++ = *t; n2 ++ ; chg2 = chg2+G->DGL[e][*t]-1; }
	  /* 	  *s2 ++ = *t; */
	  break;
	case ISADD:
	  for (i = 0, t = G->tAi[e]; i < G->nAi[e]; i++, t++)
	    if ((LesActions+(*t))->isadd[f])
	      { *s1 ++ = *t; n1 ++ ; chg1 = chg1+G->DGL[e][*t]-1; }
	  /* 	  *s1 ++ = *t; */
	    else
	      { *s2 ++ = *t; n2 ++ ; chg2 = chg2+G->DGL[e][*t]-1; }
	  /* 	  *s2 ++ = *t; */
	  break;
	case ISPRE:
	  for (i = 0, t = G->tAi[e]; i < G->nAi[e]; i++, t++)
	    if ((LesActions+(*t))->ispre[f])
	      { *s1 ++ = *t; n1 ++ ; chg1 = chg1+G->DGL[e][*t]-1; }
	  /* 	  *s1 ++ = *t; */
	    else
	      { *s2 ++ = *t; n2 ++ ; chg2 = chg2+G->DGL[e][*t]-1; }
	  /* 	  *s2 ++ = *t; */
	  break;
	}
      *s1 = *s2 = FNIL;
/*   ESSAYER    if ((n1 < n2) || (chg1*n2 < chg2*n1)) */
/*       if ((n1 < n2) || (chg1 < chg2)) */
      if ((4*n1 < n2*3) || ((3*n1 < n2*4) && (chg1 > chg2)))
	{
	  t = *S1;
	  *S1 = *S2;
	  *S2 = t;
	}
      if (++ (G->tS4S) == G->S4S+G->sS4S)
	printf("PAS POSSIBLE !!\n");
      return 1;
    }

  switch (relation)
    {
    case ISSUPP: /* DEFAULT */
      for (i = 0, t = G->tAi[e]; i < G->nAi[e]; i++, t++)
	if ((LesActions+(*t))->issup[f])
	      { *s1 ++ = *t; }
/* 	  *s1 ++ = *t; */
	else
	      { *s2 ++ = *t; }
/* 	  *s2 ++ = *t; */
      break;
    case ISADD:
      for (i = 0, t = G->tAi[e]; i < G->nAi[e]; i++, t++)
	if ((LesActions+(*t))->isadd[f])
	      { *s1 ++ = *t; }
/* 	  *s1 ++ = *t; */
	else
	      { *s2 ++ = *t; }
/* 	  *s2 ++ = *t; */
      break;
    case ISPRE:
      for (i = 0, t = G->tAi[e]; i < G->nAi[e]; i++, t++)
	if ((LesActions+(*t))->ispre[f])
	      { *s1 ++ = *t; }
/* 	  *s1 ++ = *t; */
	else
	      { *s2 ++ = *t; }
/* 	  *s2 ++ = *t; */
      break;
    }
  *s1 = *s2 = FNIL;

  /* On prends le plus grand d'abord. */
  if ((s1-*S1 < G->nAi[e]/2))
    {
      t = *S1;
      *S1 = *S2;
      *S2 = t;
    }


  if (++ (G->tS4S) == G->S4S+G->sS4S)
    printf("PAS POSSIBLE !!\n");
  return 1;
}

int UnsplitAiFromFact(int thread)
{
  (GRT[thread].tS4S) -- ;
  return 1;
}


/* Calcul du fait qui a le plus d'occurrences dans les suppressions/ajouts/
   preocnditions d'actions. */
int ChooseFactForSplit(int e, int mode, int *type, int thread)
{
  int f = NONE, nf = 0, i;
  S_GR * G = &(GRT[thread]);

  switch (mode)
    {
    case ACTIONS_2SPLIT_COMMON_SUPP:
      for (i = 0; i < 2*nFaits; i++)
	if ((G->Fi[e+1][i]) && (G->nbAM[e+1][i] > nf) && (G->nbAM[e+1][i] < G->nAi[e]))
	  {
	    f = i;
	    nf = G->nbAM[e+1][i];
	    *type = ISSUPP;
	  }
/*       printf("f = %d   %d/%d\n", f, nbAM[e+1][f], nAi[e]); */
      break;
    case ACTIONS_2SPLIT_COMMON_ADD:
      for (i = 0; i < 2*nFaits; i++)
	if ((G->Fi[e+1][i]) && (G->nbAP[e+1][i] > nf) && (G->nbAP[e+1][i] < G->nAi[e]))
	  {
	    f = i;
	    nf = G->nbAP[e+1][i];
	    *type = ISADD;
	  }
      break;
    case ACTIONS_2SPLIT_COMMON_REQ:
      for (i = 0; i < 2*nFaits; i++)
	if ((G->Fi[e][i]) && (G->nbAR[e][i] > nf) && (G->nbAR[e][i] < G->nAi[e]))
	  {
	    f = i;
	    nf = G->nbAR[e][i];
	    *type = ISPRE;
	  }
      break;
    }
  return (f);
}



void AddSplitActionsToQueue(int *A, int e, int f, int addselected, 
			    int type,
			    int thread)
     /* A la table de presence, e l'etape, add vaut 1
	si on veut ajouter les actions qui font (ajout/suppr/requis)
	critere indique a quoi on s'interesse (add/supp/pre). */
{
  int i;
#ifdef MULTI_THREADS_FILE
  S_CONS * TC = &(CST[thread]);
#endif
  
  switch (type)
    {
    case ISSUPP:
      for (i = 0; i < nActions; i++)
	if ((A[i]) && ((LesActions+i)->issup[f] == addselected))
	  { ADD_FILE_ACTION(i, e, theThreads[thread], TC); };
      break;
    case ISADD:
      for (i = 0; i < nActions; i++)
	if ((A[i]) && ((LesActions+i)->isadd[f] == addselected))
	  { ADD_FILE_ACTION(i, e, theThreads[thread], TC); };
      break;
    case ISPRE:
      for (i = 0; i < nActions; i++)
	if ((A[i]) && ((LesActions+i)->ispre[f] == addselected))
	  { ADD_FILE_ACTION(i, e, theThreads[thread], TC); };
      break;
    }
}

