#ifndef _H_stats
#define _H_stats

#include <time.h>

void PrintStats(void);

extern int NE;
extern int nSol;
extern int nChecks;

extern clock_t t_debut, t_fin;
extern time_t tt_debut, tt_fin;
extern float temps;

extern int CNE;
extern int CnSol;
extern int CnChecks;

extern clock_t Ct_debut, Ct_fin, Ct_hours;
extern time_t Ctt_debut, Ctt_fin, Ctt_hours;
extern float Ctemps;


extern float tempsLecture;


#define TOP_DEPART {nChecks = NE = nSol = 0;   t_debut = clock(); tt_debut = time(NULL); }

#define TOP_ARRIVEE { t_fin = clock(); tt_fin = time(NULL); temps = (float) (t_fin-t_debut)/CLOCKS_PER_SEC; if (tt_fin-tt_debut > 1800) temps = tt_fin-tt_debut; }

#define CTOP_DEPART {				\
    CnChecks = CNE = CnSol = 0;			\
    Ct_debut = clock();				\
    Ctt_debut = time(NULL);			\
    Ctt_hours = Ct_hours = 0;			\
  }

#define CTOP_ARRIVEE {						\
    Ct_fin = clock();						\
    Ctt_fin = time(NULL);					\
    Ctemps = (float) (Ct_fin-Ct_debut)/CLOCKS_PER_SEC;		\
    if ((Ctt_fin-Ctt_debut > 1800) &&				\
	(abs(Ctt_fin-Ctt_debut-Ctemps) > (Ctemps/100)*7))	\
      Ctemps = Ctt_fin-Ctt_debut;				\
  }

#define VERIF_TIME_LIMIT(t) {					\
    if (((t) > 0) &&							\
	(((float) (clock()-Ct_debut) / CLOCKS_PER_SEC > (float) (t))))	\
      {									\
	printf("TIME LIMIT EXCEEDED %d seconds  (%.2f)\n", t,		\
	       (float) (clock()-Ct_debut) / CLOCKS_PER_SEC);		\
	exit(0);							\
      }									\
  }


#define CSTATS_MAJ { CnChecks += nChecks; CNE += NE; CnSol += nSol; }


#define TOP_DEPART_THREAD(t) {			\
    T->Ct_debut = clock();				\
    T->NE = T->nChecks = 0;				\
    T->nRxTests = T->nRxFail = 0;			\
  }
#define TOP_ARRIVEE_THREAD(t) {	      				\
    T->Ct_fin = clock();						\
    if (T->Ct_fin < 0)							\
      T->Ctemps = ((float) LONG_MAX+LONG_MAX)/CLOCKS_PER_SEC		\
	+ (float) (T->Ct_fin-T->Ct_debut)/CLOCKS_PER_SEC;		\
    else								\
      T->Ctemps = (float) (T->Ct_fin-T->Ct_debut)/CLOCKS_PER_SEC;	\
  }



#endif
