#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "consistance.h"
#include "main.h"
#include "search.h"
#include "sequences.h"
#include "suppressions.h"
#include "structures.h"


int *PS, *tPS; /* Pile des suppressions et top de la pile. */
int **PPS, **tPPS; /* Pointeurs sur la pile PS des suppressions. */
int *PSi, *tPSi; /* Numeros des etapes ou a eu lieu la suppression. */

int **SChg, **tSChg;
int ***ISChg, ***tISChg; /* Index de la pile des changemements. */


int *PM, *tPM, *PMs, *tPMs; /* La pile (les faits et les etapes). */
int **PPM, **tPPM; /* Pointeurs sur la pile. */


S_SUPP * SST;  /* Table des structures de suppressions. */



void AllocPilesSuppressionsThread(int i)
{
  S_SUPP * S = &(SST[i]);
  THREAD T = theThreads+i;
  int size_piles_supp = (2*T->nFaits*(T->nsmax+1)+T->nActions*T->nsmax);
  int size_piles_mutex = (T->nsmax*2*T->nFaits*2*T->nFaits);
  int size_pile_chgt = 2 * T->nFaits * T->nsmax
    + T->nsmax * cadd
    + 2 * T->nFaits * T->nsmax;

  S->PS = malloc(size_piles_supp*sizeof(int));
  assert(S->PS != NULL);
  S->PSi = malloc(size_piles_supp*sizeof(int));
  assert(S->PSi != NULL);
  S->PPS = malloc(size_piles_supp*sizeof(int *));
  assert(S->PPS != NULL);
  if (UseFactsMutex)
    {
      S->PM = malloc(size_piles_mutex*sizeof(int));
      assert(S->PM != NULL);
      S->PMs = malloc(size_piles_mutex*sizeof(int));
      assert(S->PMs != NULL);
      S->PPM = malloc(2*2*T->nFaits*sizeof(int *));
      assert(S->PPM != NULL);
    }
  /* chaque fait a chaque etape n'est plus sous-but : nsmax*nFaits */
  /* chaque action a chaque etape perds un ajout-sous-but : 
     cumulAdd*nsmax*/
  /* chaque fait a chaque etape peut se retrouver ajoute par aucune action
     (ADD_FLIST) : nsmax*nFaits */
  S->SChg = malloc(size_pile_chgt * sizeof(int *));
  assert(S->SChg != NULL);
  S->ISChg = malloc(size_piles_supp * sizeof(int **));
  assert(S->ISChg != NULL);
}

void InitPilesSuppressionsThread(int t)
{
  S_SUPP * S = &(SST[t]);

  tPS = S->tPS = S->PS;
  tPSi = S->tPSi = S->PSi;
  tPPS = S->tPPS = S->PPS;
  tSChg = S->tSChg = S->SChg;
  tISChg = S->tISChg = S->ISChg;
  EXPAND_PSUPPR(t);
}


void DeFaireLastSuppressionsThreads(int ns, int t)
{
  DefaireChangesThreads(*(SST[t].tISChg-1), t);
  DefaireSuppressionsThreads(*(SST[t].tPPS-1), ns, t);
}

void DefaireChangesThreads(int ** b, int t)
{
  while (tSChg > b)
    {
      tSChg --;
      if (((int) (*(tSChg)))%2 == 1)
	{
	  int s = ((int) (*(tSChg)) - 1) / 2;
	  int f;
	  tSChg --;
	  f = ((int) (*(tSChg)));
	  RETR_FLIST_NOTHREADS(f, s);
	}
      else
	(** (tSChg)) ++;
    }
}

void DefaireSuppressionsThreads(int *limit, int ns, int t)
{
  int a, *p, s;
  S_GR * G = &(GRT[t]);

  while (tPS > limit)
    {
      tPS --, tPSi --;
      if (PSUPPR_IS_FACT( *(tPS)))
	{ 
	  ADD_FACT(PSUPPR_FACT(t), *(tPSi), G);
	}
      else
	{
	  a = PSUPPR_ACTION(t);
	  s = *(tPSi);
	  if (Sequences2Actions)
	    {
	      if (s < ns)
		for (p = Next2Actions[a]; *p != FNIL; p ++)
		  (NbPre2Seq[s+1][*p]) ++;
	      if (s > 0)
		for (p = Prev2Actions[a]; *p != FNIL; p ++)
		  (NbSucc2Seq[s-1][*p]) ++;
	    }
	  for (p = LesActions[a].pre; *p != FNIL; p ++)
	    (nbAR[s][*p]) ++;
	  for (p = LesActions[a].sup; *p != FNIL; p ++)
	    {
	      (nbAM[s+1][*p]) ++;
	      if ((IS_IN_FLIST_NOTHREADS(*p, s+1)) && (Fi[s+1][*p] == 1))
		{
		  RETR_FLIST(*p, s+1, G);
		  ADD_FLIST(*p, s+1, G);
		}
	    }
	  ADD_ACTION(a, s, G);
	}
    }
}


