#ifndef _H_suppressions
#define _H_suppressions

#include "structures.h"


/* #define MULTI_THREADS_SUPPR */


typedef struct struct_suppressions
{
  /* Suppressions */
  int *PS, *tPS;           /* Pile des suppressions.
			      PS[i]>=0 represente le fait PS[i]
			      PS[i]<0 represente l'action -(PS[i]+1). */
  int *PSi, *tPSi;         /* Pile des etapes correspondantes. */
  int **PPS, **tPPS;       /* Pile d'index. */

  /* Changes */
  int **SChg, **tSChg;     /* Pile des changements. */
  int ***ISChg, ***tISChg; /* Pile des index. */

  /* Mutex */
  int *PM, *tPM, *PMs, *tPMs; /* La pile (les faits et les etapes). */
  int **PPM, **tPPM;          /* Pile des index. */
}
  S_SUPP;

extern S_SUPP * SST;  /* Table des structures de suppressions. */


/* *************************************************************** */

extern int *PS, *tPS;
extern int **PPS, **tPPS;
extern int *PSi, *tPSi;

extern int **SChg, **tSChg;
extern int ***ISChg, ***tISChg; /* Index de la pile des changemements. */

/* Avec l'option UseFactsMutex. */
extern int *PM, *tPM, *PMs, *tPMs;
extern int **PPM, **tPPM;




#define PSUPPR_IS_ACTION(i) (((i) >= 0) && ((i) < nActions))
#define PSUPPR_IS_FACT(i) ((i) < 0)

#ifdef MULTI_THREADS_SUPPR
#define EMPILER_FSUPPR(f, i, t) { \
    * (SST[t].tPS) ++ = -((f)+1); \
    * (SST[t].tPSi) ++ = i; \
  }
#define EMPILER_ASUPPR(a, i, t) { \
    * (SST[t].tPS) ++ = (a); \
    * (SST[t].tPSi) ++ = i; \
  }

#define PSUPPR_FACT(t) (-(*(SST[t].tPS)+1))
#define PSUPPR_ACTION(t) (*(SST[t].tPS))
#else
#define EMPILER_FSUPPR(f, i, t) { \
    * (tPS) ++ = -((f)+1); \
    * (tPSi) ++ = i; \
  }
#define EMPILER_ASUPPR(a, i, t) { \
    * (tPS) ++ = (a); \
    * (tPSi) ++ = i; \
  }

#define PSUPPR_FACT(t) (-(*(tPS)+1))
#define PSUPPR_ACTION(t) (*(tPS))
#endif



#ifdef MULTI_THREADS_SUPPR
#define EMPILER_CHGT_ADD_FLIST(p, s, t) {	      	\
    *(SST[t].tSChg) ++ = (void *) (*(p));			\
    *(SST[t].tSChg) ++ = (void *) (2*((s)+1)+1); /* dernier bit a 1 */	\
}
#define EMPILER_CHGT_POUR_INCREMENT(a, t) {		\
    *(SST[t].tSChg) ++ = a; /* adresse paire */	\
  }
#else
#define EMPILER_CHGT_ADD_FLIST(p, s, t) {	      	\
    *(tSChg) ++ = (void *) (*(p));			\
    *(tSChg) ++ = (void *) (2*((s)+1)+1); /* dernier bit a 1 */	\
}
#define EMPILER_CHGT_POUR_INCREMENT(a, t) {		\
    *(tSChg) ++ = a; /* adresse paire */	\
  }
#endif


#ifdef MULTI_THREADS_SUPPR
#define EXPAND_PSUPPR(t) {		\
    *(SST[t].tPPS) ++ = SST[t].tPS;	\
    *(SST[t].tISChg) ++ = SST[t].tSChg; \
  }
#else
#define EXPAND_PSUPPR(t) {		\
    *(SST[t].tPPS) ++ = tPS;	\
    *(SST[t].tISChg) ++ = tSChg; \
  }
#endif


#define UNEXPAND_PSUPPR(t) {				\
    (SST[t].tPPS) --;					\
    (SST[t].tISChg) --;					\
  }



void AllocPilesSuppressionsThread(int i);
void InitPilesSuppressionsThread(int i);
void DeFaireLastSuppressionsThreads(int ns, int t);
void DefaireSuppressionsThreads(int *limit, int ns, int t);
void DefaireChangesThreads(int **b, int t);

void AllocPilesSuppressions(int na, int nf, int ne, int thread);
void RestituePilesSuppressions(int thread);
void InitPilesSuppressions(void);
void DeFaireLastSuppressions(int ns);
void DefaireSuppressions(int *limit, int ns);
void DefaireChanges(int **b);

#endif
